open Dib_types

(* establish connection, return socket *)
let connect host port =
  let realhost = (Unix.gethostbyname host) in
  let addr:Unix.sockaddr = Unix.ADDR_INET( realhost.Unix.h_addr_list.(0), port ) in
  let sock = {
     sock = Unix.socket Unix.PF_INET Unix.SOCK_STREAM 0;
     log  = open_out "game.log"
  } in
  Unix.connect sock.sock addr;
  sock

(* send line to server *)
let send_ln sock str =
(*  output_string sock.log ("> " ^ str ^"\n"); flush sock.log; *)
  Unix.send sock.sock (str^"\n") 0 ((String.length str)+1) []
;;

(* does not read final newline *)
let readline sock =
  print_char '['; flush stdout;
  let buflen = 256 in 
  let buf = String.create buflen in
  let str = ref "" in
  let offset = ref (Unix.read sock.sock buf 0 1) in
  while buf.[!offset - 1] <> '\n' do
    if !offset = buflen then (
      str := !str ^ buf;
      offset := 0
    );
    offset := !offset + Unix.read sock.sock buf !offset 1;
  done;
  print_char ']'; flush stdout;
  str := !str ^ String.sub buf 0 (!offset-1);
(*  output_string sock.log ("< " ^ !str ^ "\n"); flush sock.log; *)
  !str

  
